#define INCL_DOS
#define INCL_DOSERRORS
#include <os2.h>

#ifndef __MT__
# define __ST_MT_ERRNO__
#endif
#include <errno.h>

#if defined(__WATCOMC__)
# error You should need a port for Watcom.
#endif

extern int _CRT_init (void);
extern void _CRT_term (void);
extern void __ctordtorInit (void);
extern void __ctordtorTerm (void);

extern HMODULE localcharset_set_os2_hmodule (HMODULE hm);

#define EXTERNAL_ERRNO_EILSEQ 1
#define EXTERNAL_ERRNO_E2BIG  2
#define EXTERNAL_ERRNO_ENOMEM 3
#define EXTERNAL_ERRNO_EINVAL -1

extern int  libiconv_clear_errno (void);
extern int  libiconv_get_internal_errno (void);
extern int  libiconv_get_errno (void);

int  libiconv_clear_errno (void)
{
  errno = 0;
}

int  libiconv_get_internal_errno (void)
{
  return errno;
}

int  libiconv_get_errno (void)
{
  int e;
  switch (errno) {
    case E2BIG:
      e = EXTERNAL_ERRNO_E2BIG; break;
    case ENOMEM:
      e = EXTERNAL_ERRNO_ENOMEM; break;
    case ENOENT:
#ifdef EILSEQ
    case EILSEQ:
#endif
      e = EXTERNAL_ERRNO_EILSEQ; break;
    case 0:
      e = 0; break;
    case EINVAL:
    default:
      e = EXTERNAL_ERRNO_EINVAL; break;
  }
  return e;
}

unsigned long _DLL_InitTerm (unsigned long hm, unsigned long flag)
{
  unsigned long rc = FALSE;
  switch (flag)
    {
    case 0:
      if (_CRT_init () == 0) {
        __ctordtorInit ();
        localcharset_set_os2_hmodule ((HMODULE)hm);
        rc = TRUE;
      }
      break;
    case 1:
      __ctordtorTerm ();
      _CRT_term ();
      rc = TRUE;
      break;
    }
  return rc;
}



